﻿@using System.Web.UI.WebControls;

@Html.Common().DevExpress().GridView(
        setting =>
        {
            setting.Name = "DetailPartGrid";
            setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
            setting.Width = Unit.Pixel(800);

            setting.CommandColumn.ShowSelectCheckbox = true;
            setting.CommandColumn.Visible = true;
            setting.CommandColumn.ClearFilterButton.Visible = true;
            setting.CommandColumn.Width = Unit.Pixel(30);

            setting.CallbackRouteValues = new { Controller = "DailyOrderPrintingSPEX", Action = "PopupDataPartDetail" };
            setting.KeyFieldName = "ITEM_NO";
            setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
            setting.Settings.VerticalScrollableHeight = 250;
            setting.SettingsPager.Position = PagerPosition.Bottom;
            setting.SettingsPager.FirstPageButton.Visible = true;
            setting.SettingsPager.LastPageButton.Visible = true;
            setting.Settings.ShowFilterRow = true;
            setting.Settings.ShowFilterRowMenu = true;
            setting.ClientSideEvents.BeginCallback = "OnBeginCallbackDetailPart";

            setting.SettingsPager.PageSizeItemSettings.Visible = true;
            setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
            setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";

            setting.CustomJSProperties = (s, e) =>
            {
                MVCxGridView grid = (MVCxGridView)s;
                int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
                int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
                object[] ItemNo = new object[end - startIndex];
                object[] PartNo = new object[end - startIndex];
                object[] OrderPlanQty = new object[end - startIndex];
                object[] QtyPerContainer = new object[end - startIndex];
                object[] ManifestNo = new object[end - startIndex];

                for (int n = startIndex; n < end; n++)
                {
                    ItemNo[n - startIndex] = grid.GetRowValues(n, "ITEM_NO");
                    PartNo[n - startIndex] = grid.GetRowValues(n, "PART_NO");
                    OrderPlanQty[n - startIndex] = grid.GetRowValues(n, "ORDER_PLAN_QTY_LOT");
                    QtyPerContainer[n - startIndex] = grid.GetRowValues(n, "QTY_PER_CONTAINER");
                    ManifestNo[n - startIndex] = grid.GetRowValues(n, "MANIFEST_NO");
                }

                e.Properties["cpItemNo"] = ItemNo;
                e.Properties["cpPartNo"] = PartNo;
                e.Properties["cpOrderPlanQty"] = OrderPlanQty;
                e.Properties["cpQtyPerContainer"] = QtyPerContainer;
                e.Properties["cpManifestNo"] = ManifestNo;

                grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
            };

            setting.Columns.Add(
                col =>
                {
                    col.FieldName = "ITEM_NO";
                    col.Caption = "Item No";
                    col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    col.Width = Unit.Pixel(10);
                });
            setting.Columns.Add(
                col =>
                {
                    col.FieldName = "PART_NO";
                    col.Caption = "Part No";
                    col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    col.Width = Unit.Pixel(100);

                    //col.SetDataItemTemplateContent(
                    //content =>
                    //{
                    //    Html.DevExpress().HyperLink(hlSettings =>
                    //    {
                    //        hlSettings.Name = string.Format("hl_{0}", (content as GridViewDataItemTemplateContainer).VisibleIndex);
                    //        hlSettings.NavigateUrl = "javascript:void(0)";
                    //        hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenUrl('{0}', '{1}', '{2}', '{3}'); }}", DataBinder.Eval(content.DataItem, "PART_NO"), DataBinder.Eval(content.DataItem, "KANBAN_NO"), DataBinder.Eval(content.DataItem, "PartName"), DataBinder.Eval(content.DataItem, "ORDER_PLAN_QTY_LOT"));
                    //        hlSettings.Properties.Text = (content as GridViewDataItemTemplateContainer).Text;
                    //    }).Render();
                    //});
                });
            setting.Columns.Add(
                col =>
                {
                    col.FieldName = "PartName";
                    col.Caption = "Part Name";
                    col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                    col.Width = Unit.Pixel(400);
                });
            setting.Columns.Add(
                col =>
                {
                    col.FieldName = "KANBAN_NO";
                    col.Caption = "Unique No";
                    col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                    col.Width = Unit.Pixel(80);
                });
            setting.Columns.Add(
                col =>
                {
                    col.FieldName = "ORDER_PLAN_QTY_LOT";
                    col.Caption = "Kanban Qty";
                    col.ColumnType = MVCxGridViewColumnType.SpinEdit;
                    col.Width = Unit.Pixel(100);
                    col.SetDataItemTemplateContent(c =>
                    {
                        Html.DevExpress().SpinEdit(txtSettings =>
                        {
                            txtSettings.Name = string.Format("orderPlanQty_1{0}", (c as GridViewDataItemTemplateContainer).VisibleIndex);
                            txtSettings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
                            txtSettings.Properties.NumberType = SpinEditNumberType.Integer;
                            txtSettings.Properties.ClientSideEvents.NumberChanged = "SetOrderPlanQty";
                            txtSettings.Properties.MinValue = 0;
                            txtSettings.Properties.MaxValue = 999999;
                            txtSettings.Properties.MaxLength = 6;
                            txtSettings.Properties.Style.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Right;
                        }).Bind(DataBinder.Eval(c.DataItem, c.Column.FieldName)).Render();
                    });
                });
            setting.Columns.Add(
                col =>
                {
                    col.FieldName = "ORDER_QTY";
                    col.Caption = "Order Qty";
                    col.ColumnType = MVCxGridViewColumnType.SpinEdit;
                    col.Width = Unit.Pixel(100);
                    col.SetDataItemTemplateContent(container =>
                    {
                        Html.DevExpress().Label(hlSettings =>
                        {
                            hlSettings.Name = string.Format("OrderQty_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                            hlSettings.Text = (container as GridViewDataItemTemplateContainer).Text;
                        }).Render();
                    });
                });
        }).Bind(ViewData["partDailyData"]).GetHtml()